package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsBankActivityRosterRateExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsBankActivityRosterRateExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdIsNull() {
            addCriterion("bank_activity_id is null");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdIsNotNull() {
            addCriterion("bank_activity_id is not null");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdEqualTo(Long value) {
            addCriterion("bank_activity_id =", value, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdNotEqualTo(Long value) {
            addCriterion("bank_activity_id <>", value, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdGreaterThan(Long value) {
            addCriterion("bank_activity_id >", value, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdGreaterThanOrEqualTo(Long value) {
            addCriterion("bank_activity_id >=", value, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdLessThan(Long value) {
            addCriterion("bank_activity_id <", value, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdLessThanOrEqualTo(Long value) {
            addCriterion("bank_activity_id <=", value, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdIn(List<Long> values) {
            addCriterion("bank_activity_id in", values, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdNotIn(List<Long> values) {
            addCriterion("bank_activity_id not in", values, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdBetween(Long value1, Long value2) {
            addCriterion("bank_activity_id between", value1, value2, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityIdNotBetween(Long value1, Long value2) {
            addCriterion("bank_activity_id not between", value1, value2, "bankActivityId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdIsNull() {
            addCriterion("bank_activity_roster_id is null");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdIsNotNull() {
            addCriterion("bank_activity_roster_id is not null");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdEqualTo(Long value) {
            addCriterion("bank_activity_roster_id =", value, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdNotEqualTo(Long value) {
            addCriterion("bank_activity_roster_id <>", value, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdGreaterThan(Long value) {
            addCriterion("bank_activity_roster_id >", value, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdGreaterThanOrEqualTo(Long value) {
            addCriterion("bank_activity_roster_id >=", value, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdLessThan(Long value) {
            addCriterion("bank_activity_roster_id <", value, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdLessThanOrEqualTo(Long value) {
            addCriterion("bank_activity_roster_id <=", value, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdIn(List<Long> values) {
            addCriterion("bank_activity_roster_id in", values, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdNotIn(List<Long> values) {
            addCriterion("bank_activity_roster_id not in", values, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdBetween(Long value1, Long value2) {
            addCriterion("bank_activity_roster_id between", value1, value2, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andBankActivityRosterIdNotBetween(Long value1, Long value2) {
            addCriterion("bank_activity_roster_id not between", value1, value2, "bankActivityRosterId");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNull() {
            addCriterion("mer_id is null");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNotNull() {
            addCriterion("mer_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerIdEqualTo(Long value) {
            addCriterion("mer_id =", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotEqualTo(Long value) {
            addCriterion("mer_id <>", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThan(Long value) {
            addCriterion("mer_id >", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mer_id >=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThan(Long value) {
            addCriterion("mer_id <", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThanOrEqualTo(Long value) {
            addCriterion("mer_id <=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdIn(List<Long> values) {
            addCriterion("mer_id in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotIn(List<Long> values) {
            addCriterion("mer_id not in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdBetween(Long value1, Long value2) {
            addCriterion("mer_id between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotBetween(Long value1, Long value2) {
            addCriterion("mer_id not between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andPlatformNoIsNull() {
            addCriterion("platform_no is null");
            return (Criteria) this;
        }

        public Criteria andPlatformNoIsNotNull() {
            addCriterion("platform_no is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformNoEqualTo(String value) {
            addCriterion("platform_no =", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoNotEqualTo(String value) {
            addCriterion("platform_no <>", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoGreaterThan(String value) {
            addCriterion("platform_no >", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoGreaterThanOrEqualTo(String value) {
            addCriterion("platform_no >=", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoLessThan(String value) {
            addCriterion("platform_no <", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoLessThanOrEqualTo(String value) {
            addCriterion("platform_no <=", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoLike(String value) {
            addCriterion("platform_no like", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoNotLike(String value) {
            addCriterion("platform_no not like", value, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoIn(List<String> values) {
            addCriterion("platform_no in", values, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoNotIn(List<String> values) {
            addCriterion("platform_no not in", values, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoBetween(String value1, String value2) {
            addCriterion("platform_no between", value1, value2, "platformNo");
            return (Criteria) this;
        }

        public Criteria andPlatformNoNotBetween(String value1, String value2) {
            addCriterion("platform_no not between", value1, value2, "platformNo");
            return (Criteria) this;
        }

        public Criteria andCupNoIsNull() {
            addCriterion("cup_no is null");
            return (Criteria) this;
        }

        public Criteria andCupNoIsNotNull() {
            addCriterion("cup_no is not null");
            return (Criteria) this;
        }

        public Criteria andCupNoEqualTo(String value) {
            addCriterion("cup_no =", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoNotEqualTo(String value) {
            addCriterion("cup_no <>", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoGreaterThan(String value) {
            addCriterion("cup_no >", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoGreaterThanOrEqualTo(String value) {
            addCriterion("cup_no >=", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoLessThan(String value) {
            addCriterion("cup_no <", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoLessThanOrEqualTo(String value) {
            addCriterion("cup_no <=", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoLike(String value) {
            addCriterion("cup_no like", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoNotLike(String value) {
            addCriterion("cup_no not like", value, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoIn(List<String> values) {
            addCriterion("cup_no in", values, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoNotIn(List<String> values) {
            addCriterion("cup_no not in", values, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoBetween(String value1, String value2) {
            addCriterion("cup_no between", value1, value2, "cupNo");
            return (Criteria) this;
        }

        public Criteria andCupNoNotBetween(String value1, String value2) {
            addCriterion("cup_no not between", value1, value2, "cupNo");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdIsNull() {
            addCriterion("welfare_rates_id is null");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdIsNotNull() {
            addCriterion("welfare_rates_id is not null");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdEqualTo(Long value) {
            addCriterion("welfare_rates_id =", value, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdNotEqualTo(Long value) {
            addCriterion("welfare_rates_id <>", value, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdGreaterThan(Long value) {
            addCriterion("welfare_rates_id >", value, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdGreaterThanOrEqualTo(Long value) {
            addCriterion("welfare_rates_id >=", value, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdLessThan(Long value) {
            addCriterion("welfare_rates_id <", value, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdLessThanOrEqualTo(Long value) {
            addCriterion("welfare_rates_id <=", value, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdIn(List<Long> values) {
            addCriterion("welfare_rates_id in", values, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdNotIn(List<Long> values) {
            addCriterion("welfare_rates_id not in", values, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdBetween(Long value1, Long value2) {
            addCriterion("welfare_rates_id between", value1, value2, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andWelfareRatesIdNotBetween(Long value1, Long value2) {
            addCriterion("welfare_rates_id not between", value1, value2, "welfareRatesId");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelIsNull() {
            addCriterion("preferential_model is null");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelIsNotNull() {
            addCriterion("preferential_model is not null");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelEqualTo(Integer value) {
            addCriterion("preferential_model =", value, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelNotEqualTo(Integer value) {
            addCriterion("preferential_model <>", value, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelGreaterThan(Integer value) {
            addCriterion("preferential_model >", value, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelGreaterThanOrEqualTo(Integer value) {
            addCriterion("preferential_model >=", value, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelLessThan(Integer value) {
            addCriterion("preferential_model <", value, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelLessThanOrEqualTo(Integer value) {
            addCriterion("preferential_model <=", value, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelIn(List<Integer> values) {
            addCriterion("preferential_model in", values, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelNotIn(List<Integer> values) {
            addCriterion("preferential_model not in", values, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelBetween(Integer value1, Integer value2) {
            addCriterion("preferential_model between", value1, value2, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andPreferentialModelNotBetween(Integer value1, Integer value2) {
            addCriterion("preferential_model not between", value1, value2, "preferentialModel");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNull() {
            addCriterion("start_time is null");
            return (Criteria) this;
        }

        public Criteria andStartTimeIsNotNull() {
            addCriterion("start_time is not null");
            return (Criteria) this;
        }

        public Criteria andStartTimeEqualTo(Date value) {
            addCriterion("start_time =", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotEqualTo(Date value) {
            addCriterion("start_time <>", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThan(Date value) {
            addCriterion("start_time >", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("start_time >=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThan(Date value) {
            addCriterion("start_time <", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeLessThanOrEqualTo(Date value) {
            addCriterion("start_time <=", value, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeIn(List<Date> values) {
            addCriterion("start_time in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotIn(List<Date> values) {
            addCriterion("start_time not in", values, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeBetween(Date value1, Date value2) {
            addCriterion("start_time between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andStartTimeNotBetween(Date value1, Date value2) {
            addCriterion("start_time not between", value1, value2, "startTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNull() {
            addCriterion("end_time is null");
            return (Criteria) this;
        }

        public Criteria andEndTimeIsNotNull() {
            addCriterion("end_time is not null");
            return (Criteria) this;
        }

        public Criteria andEndTimeEqualTo(Date value) {
            addCriterion("end_time =", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotEqualTo(Date value) {
            addCriterion("end_time <>", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThan(Date value) {
            addCriterion("end_time >", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("end_time >=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThan(Date value) {
            addCriterion("end_time <", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeLessThanOrEqualTo(Date value) {
            addCriterion("end_time <=", value, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeIn(List<Date> values) {
            addCriterion("end_time in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotIn(List<Date> values) {
            addCriterion("end_time not in", values, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeBetween(Date value1, Date value2) {
            addCriterion("end_time between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andEndTimeNotBetween(Date value1, Date value2) {
            addCriterion("end_time not between", value1, value2, "endTime");
            return (Criteria) this;
        }

        public Criteria andRatesIsNull() {
            addCriterion("rates is null");
            return (Criteria) this;
        }

        public Criteria andRatesIsNotNull() {
            addCriterion("rates is not null");
            return (Criteria) this;
        }

        public Criteria andRatesEqualTo(String value) {
            addCriterion("rates =", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesNotEqualTo(String value) {
            addCriterion("rates <>", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesGreaterThan(String value) {
            addCriterion("rates >", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesGreaterThanOrEqualTo(String value) {
            addCriterion("rates >=", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesLessThan(String value) {
            addCriterion("rates <", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesLessThanOrEqualTo(String value) {
            addCriterion("rates <=", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesLike(String value) {
            addCriterion("rates like", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesNotLike(String value) {
            addCriterion("rates not like", value, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesIn(List<String> values) {
            addCriterion("rates in", values, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesNotIn(List<String> values) {
            addCriterion("rates not in", values, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesBetween(String value1, String value2) {
            addCriterion("rates between", value1, value2, "rates");
            return (Criteria) this;
        }

        public Criteria andRatesNotBetween(String value1, String value2) {
            addCriterion("rates not between", value1, value2, "rates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesIsNull() {
            addCriterion("preferential_rates is null");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesIsNotNull() {
            addCriterion("preferential_rates is not null");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesEqualTo(String value) {
            addCriterion("preferential_rates =", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesNotEqualTo(String value) {
            addCriterion("preferential_rates <>", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesGreaterThan(String value) {
            addCriterion("preferential_rates >", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesGreaterThanOrEqualTo(String value) {
            addCriterion("preferential_rates >=", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesLessThan(String value) {
            addCriterion("preferential_rates <", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesLessThanOrEqualTo(String value) {
            addCriterion("preferential_rates <=", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesLike(String value) {
            addCriterion("preferential_rates like", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesNotLike(String value) {
            addCriterion("preferential_rates not like", value, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesIn(List<String> values) {
            addCriterion("preferential_rates in", values, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesNotIn(List<String> values) {
            addCriterion("preferential_rates not in", values, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesBetween(String value1, String value2) {
            addCriterion("preferential_rates between", value1, value2, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andPreferentialRatesNotBetween(String value1, String value2) {
            addCriterion("preferential_rates not between", value1, value2, "preferentialRates");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}